# vim: set fileencoding=ascii ts=4 sw=4 sts=0 :
#
# ZView.py
#
# Copyright (C) 2004, Shu KONNO <owa@bg.wakwak.com> All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted, provided that
# the above copyright notice appear in all copies and that both that copyright
# notice and this permission notice appear in supporting documentation, and that
# the name of Atsuo Ishimoto not be used in advertising or publicity pertaining
# to distribution of the software without specific, written prior permission.
#
# SHU KONNO DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
# INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
# EVENT SHALL SHIBAT ATSUSHI BE LIABLE FOR ANY SPECIAL, INDIRECT OR
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
# USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
# OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
# PERFORMANCE OF THIS SOFTWARE.
#
##############################################################################
"""ZView: provide methods to view shogi diagram."""

__version__='$Revision: 0.1.1.0 $'[11:-2]

from board9.ViewSpace import ViewSpace

def showCurrent(REQUEST, size=0):
	"""Method to show ZShogi instance."""
	pick = REQUEST.SESSION.get('ss_pick', '')
	diag = REQUEST.SESSION.get('ss_diag', '')
	view = ViewSpace(diagram=diag, size=size)
	return view.getWholeImage()

def showBoard(REQUEST, size=0):
	"""Method to show board image."""
	pick = REQUEST.SESSION.get('ss_pick', '')
	diag = REQUEST.SESSION.get('ss_diag', '')
	view = ViewSpace(diagram=diag, size=size)
	return view.getBoardImage(pick)

def showBlacket1(REQUEST, size=0):
	"""Method to show blackate image of blacks."""
	pick = REQUEST.SESSION.get('ss_pick', '')
	diag = REQUEST.SESSION.get('ss_diag', '')
	view = ViewSpace(diagram=diag, size=size)
	return view.getBlackBlacket(pick)

def showBlacket2(REQUEST, size=0):
	"""Method to show blackate image of whites."""
	pick = REQUEST.SESSION.get('ss_pick', '')
	diag = REQUEST.SESSION.get('ss_diag', '')
	view = ViewSpace(diagram=diag, size=size)
	return view.getWhiteBlacket(pick)

