# vim: set fileencoding=ascii ts=4 sw=4 sts=0 :
# Copyright (C) 2004, Shu KONNO <owa@bg.wakwak.com> All Rights Reserved.
import PIL.Image
import opening

class CBoardSpace:
	def __init__(self, xo=0, yo=0, xs=0, ys=0, b={}, w={}):
		self.xo = xo
		self.yo = yo
		self.xs = xs
		self.ys = ys
		self.blacks = b
		self.whites = w
		self.imgpath = None

	def getColRow(self, pos):
		m = 9 - (pos[0] - self.xo) / self.xs;
		n = 1 + (pos[1] - self.yo) / self.ys;
		m = min(max(1, m), 9)
		n = min(max(1, n), 9)
		return str(m) + str(n)

	def getAbsPosition(self, pos):
		x = self.xo + self.xs * (9 - int(pos[0]))
		y = self.yo + self.ys * (int(pos[1]) - 1)
		return x, y

	def getBoardImage(self, space, pick=None):
		if self.imgpath:
			image = PIL.Image.open(self.imgpath,'r')
			self.__setPieces(image, self.pasteOnBoard, space, 1)
			self.__setPieces(image, self.pasteOnBoard, space, 2)
			if pick and pick[2]:
				self.pastePickImage(image, pick)
			return image

	def __setPieces(self, base, paste, space, bw=1):
		list = space.getStays(bw)
		pieces = (bw == 1 and self.blacks) or self.whites
		for pi in list:
			x, y = self.getAbsPosition((int(pi[-2]), int(pi[-1])))
			img = pieces[pi[:-2]]
			paste(base, img, x, y)

