# vim: set fileencoding=euc-jp ts=4 sw=4 sts=0 formatoptions= :
# Copyright (C) 2004, Shu KONNO <owa@bg.wakwak.com> All Rights Reserved.
from Tkinter import *
import ImageTk
import PIL.Image
import cStringIO
from board9 import opening
from board9.ViewSpace import ViewSpace

class ZFrame(Frame):
	def controlBox(self, frame): pass
	def getListBox(self, frame): pass
	def proc(self, pos, id): pass
	def selected(self, id): pass

	def __init__(self, master, diag='', size=0):
		self.size = size
		self.diag = diag
		self.pick = None
		self.listbox = None

		Frame.__init__(self, master)
		frame1 = Frame(self, bd=4)
		frame2 = Frame(self, bd=0)
		frame3 = Frame(self, bd=0)
		frame4 = Frame(self, bd=0)
		frame1.pack(side=TOP, fill=Y)
		frame2.pack(side=TOP, fill=Y)
		frame3.pack(side=TOP, fill=Y)
		frame4.pack(side=TOP, fill=Y)
		self.__frameTop(frame1)
		self.controlBox(frame3)
		self.__frameBot(frame4)

		panel1 = Frame(frame2, bd=0)
		panel2 = Frame(frame2, bd=0)
		panel3 = Frame(frame2, bd=0)
		panel1.pack(side=LEFT, fill=Y)
		panel2.pack(side=LEFT, fill=Y)
		panel3.pack(side=LEFT, fill=Y)

		self.__frameWest(panel1)
		self.__frameCenter(panel2)
		self.__frameEast(panel3)

		self.__items = None
		self.__poll()
		self.showImage()

	def __poll(self):
		if self.listbox:
			items = self.listbox.curselection()
			if items != self.__items:
				if items:
					n = int(items[0])
					self.selected(n)
				self.__items = items
			self.after(250, self.__poll)

	def __frameTop(self, frame):
		self.message = StringVar()
		msg = Label(frame, textvariable=self.message, bd=1,
			width=40, height=1, relief=SUNKEN, fg='DarkBlue')
		msg.pack(side=TOP)
		self.message.set('')

	def __frameBot(self, frame):
		self.diagPanel = StringVar()
		msg = Label(frame, textvariable=self.diagPanel, bd=1, relief=SUNKEN,
			fg='Black', anchor=NW, width=48, height=4, wraplength=336,
			justify=LEFT, font=("A", 10))
			#fg='Black', anchor=NW, width=48, height=4, wraplength=336,
			#justify=LEFT, font=("A", 12))
		msg.pack(side=TOP)
		self.diagPanel.set('')

	def __frameCenter(self, frame):
		if self.size:
			self.canvBoard = Canvas(frame, width=318, height=354)
		else:
			self.canvBoard = Canvas(frame, width=152, height=170)
		self.canvBoard.bind('<Button-1>', self.__touch)
		self.canvBoard.pack(fill=BOTH)

	def __frameWest(self, frame):
		if self.size:
			self.canvBlacket2 = Canvas(frame, width=96, height=128)
		else:
			self.canvBlacket2 = Canvas(frame, width=24, height=150)
		self.canvBlacket2.bind('<Button-1>', self.__pick2)
		self.canvBlacket2.pack(fill=X, expand=YES, anchor=NE)

	def __frameEast(self, frame):
		panel = self.getListBox(frame)
		if self.size:
			panel.pack(expand=YES, anchor=CENTER)
			self.canvBlacket1 = Canvas(frame, width=96, height=128)
			self.canvBlacket1.pack(fill=X, expand=YES, anchor=SW)
		else:
			self.canvBlacket1 = Canvas(frame, width=24, height=150)
			self.canvBlacket1.pack(side=LEFT)
			panel.pack(side=LEFT)
		self.canvBlacket1.bind('<Button-1>', self.__pick1)

	def __touch(self, event):
		self.proc((event.x, event.y), 0)

	def __pick1(self, event):
		self.proc((event.x, event.y), 1)

	def __pick2(self, event):
		self.proc((event.x, event.y), 2)

	def __showBlacket1(self):
		if self.canvBlacket1.find_withtag('IMG1'):
			self.canvBlacket1.delete('IMG1')
		space = ViewSpace(self.diag, self.size)
		s = space.getBlackBlacket(self.pick)
		img = PIL.Image.open(cStringIO.StringIO(s))
		self.img1 = ImageTk.PhotoImage(img)
		self.canvBlacket1.create_image(
			0, 0, image=self.img1, anchor=NW, tags='IMG1')

	def __showBlacket2(self):
		if self.canvBlacket2.find_withtag('IMG2'):
			self.canvBlacket2.delete('IMG2')
		space = ViewSpace(self.diag, self.size)
		s = space.getWhiteBlacket(self.pick)
		img = PIL.Image.open(cStringIO.StringIO(s))
		self.img2 = ImageTk.PhotoImage(img)
		self.canvBlacket2.create_image(
			0, 0, image=self.img2, anchor=NW, tags='IMG2')

	def showImage(self):
		if self.canvBoard.find_withtag('IMG0'):
			self.canvBoard.delete('IMG0')
		space = ViewSpace(self.diag, self.size)
		s = space.getBoardImage(self.pick)
		img = PIL.Image.open(cStringIO.StringIO(s))
		self.img = ImageTk.PhotoImage(img)
		self.canvBoard.create_image(
			0, 0, image=self.img, anchor=NW, tags='IMG0')
		self.__showBlacket1()
		self.__showBlacket2()

	def showImageAll(self):
		if self.canvBoard.find_withtag('IMG0'):
			self.canvBoard.delete('IMG0')
		space = ViewSpace(self.diag, self.size)
		s = space.getWholeImage(self.pick)
		img = PIL.Image.open(cStringIO.StringIO(s))
		self.img = ImageTk.PhotoImage(img)
		self.canvBoard.create_image(
			0, 0, image=self.img, anchor=NW, tags='IMG0')

